<?php

// If the file isn't called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');

// Load the language file
loadLanguage('Achievements');

//Add mod settings in admin panel.	
function AchievementsProfileArea(&$profile_areas)
{
	global $txt, $context;
	$profile_areas['edit_profile']['areas'] += array('achievements' => array(
		'label' => $txt['achievements_display'],
		'file' => 'achievements/Achievements.php',
		'function' => 'editVisibleAchievements',
		'enabled' => $context['user']['is_owner'],
		'icon' => 'stats',
		'sc' => 'post',
		'permission' => array(
			'own' => array('profile_extra_any', 'profile_extra_own'),
			'any' => array(),
		),),
	);
	return $profile_areas;
}

function AchievementsPermissions(&$permissionGroups, &$permissionList, &$leftPermissionGroups, &$hiddenPermissions, &$relabelPermissions)
{
	$permissionGroups['membergroup'] += array(sizeof($permissionGroups['membergroup']) => 'achievements');
	
	$permissionList['membergroup'] += array(
		'achievements_admin' => array(false, 'achievements'),
	);
}

// Achievement reward mamangement page
function editVisibleAchievements($memID)
{
	global $smcFunc, $context, $db_prefix, $modSettings, $txt, $scripturl;

	if (isset($_GET['do']) && $_GET['do'] == 'add') {
		$ciphering = "AES-128-CTR"; 
		$decryption_key = $modSettings['cjdsmfachievementsSSLkey'];
		$options = 0;

		// Use openssl_decrypt() function to decrypt the data 
		$decryption = openssl_decrypt (rawurldecode($_GET['hash']), $ciphering,
				$decryption_key, $options, rawurldecode($_GET['iv'])); 
		if (is_numeric($decryption)) {
			userMaybeGiveMemberAchievement($decryption);
		}
	}

	if (isset($_GET['do']) && $_GET['do'] == 'save')
	{
		foreach($_POST['ach_list'] as $id) {
			if (!is_numeric($id)) {
				continue;
			}
			$displayValue = 0;
			if (array_key_exists($id, $_POST['display']) && $_POST['display'][$id] == 'on') {
				$displayValue = 1;
			}
			$smcFunc['db_query']('', "
				UPDATE {db_prefix}achievements_members
				SET
					`display` = {int:display}
				WHERE id = {int:id}",
				array(
					'id' => $id,
					'display' =>  $displayValue,
				));
		}

		// This is used in the template for the message at the top
		$context['achievement_edit_message'] = $txt['achievement_saved'];
	}

	// If the sort method isn't defined, assume a default
	if (!isset($_GET['sort']))
		$_GET['sort'] = '0';
	if (!isset($_GET['sortDir']))
		$_GET['sortDir'] = '0';
	
	// Get the sort type
	switch($_GET['sort'])
	{
		case 0:
			$context['achievements_members']['sort_type'] = $txt['achievement_name'];
			$sortQuery = 'achievement_name';
			break;
		default:
			fatal_error("Invalid sort method passed");
			break;
	}
	
	// And the direction
	switch($_GET['sortDir'])
	{
		case 0:
			$context['achievements_members']['sort_dir'] = $txt['achievements_asc'];
			$sortDirQuery = 'ASC';
			break;
		case 1:
			$context['achievements_members']['sort_dir'] = $txt['achievements_desc'];
			$sortDirQuery = 'DESC';
			break;	
		default:
			fatal_error("Invalid sort direction passed");
			break;
	}	
	// Tell the template we need the sort box at the top
    $context['achievements_members']['sort'] = true;
    $context['achievements_members']['member'] = $memID;

	// Get the number of achievements assigned
	$result = $smcFunc['db_query']('', "
		SELECT COUNT(id)
		FROM {db_prefix}achievements_members
		WHERE ownerid = {int:member}",
		array(
			'member' => $memID,
		));
	list ($context['achievements_members']['item_count']) = $smcFunc['db_fetch_row']($result);

	// !!! constructPageIndex()!
	// If the page is not set, assume page 1
	if (!isset($_GET['page']))
		$_GET['page'] = 1;
	
	// The page count - Total number of items divided by number per page
	$context['achievements_members']['pages']['total'] = ceil($context['achievements_members']['item_count'] / $modSettings['achievementInfoPerPage']);
	// First item
	$firstItem = ($_GET['page'] - 1) * $modSettings['achievementInfoPerPage'];

	// Start with empty items array
	$context['achievements_members']['members'] = array();
	// Get all the items on this page
	$result = $smcFunc['db_query']('', '
		SELECT i.image as achievement_image, i.name as achievement_name, am.id as id, am.display as display
		FROM {db_prefix}achievements_members as am
			INNER JOIN {db_prefix}achievements_info AS i ON (am.achievement = i.id)
		WHERE ownerid = {int:member} AND i.enabled = 1
		ORDER BY {raw:sort} {raw:sortdir}
		LIMIT {int:firstItem}, {int:perPage}',
		array(
			'member' => $memID,
			'sort' => $sortQuery,
			'sortdir' => $sortDirQuery,
			'firstItem' => $firstItem,
			'perPage' => $modSettings['achievementInfoPerPage'],
		)
	);

	// Loop through results...
    while ($row = $smcFunc['db_fetch_assoc']($result))
    {
		// ... and add it to the array
		$context['achievements_members']['members'][] = array(
            'id' => $row['id'],
            // 'name' => $row['member_name'],
			'achievement_name' => $row['achievement_name'],
            'achievement_image' => $row['achievement_image'],
            'display' => $row['display'],
        );
	}

	$smcFunc['db_free_result']($result);
	
	// Miscellaneous stuff
	$context['achievements_members']['pages']['current'] = $_GET['page'];
	$context['achievements_members']['pages']['link'] = $scripturl . '?action=profile;area=achievements;sort=' . $_GET['sort'] . ';sortDir=' . $_GET['sortDir'];
	if (isset($context['achievements_members']['category']))
        $context['achievements_members']['pages']['link'] .= ';cat=' . $context['achievements_members']['category'];

    // We need to load the member achievements template
	$context['sub_template'] = 'edit_visible_achievements';
	// Set the page title
	$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_info'];
	// Load the administration template
	loadTemplate('Achievements');
}

function userMaybeGiveMemberAchievement($achievementid) {
	global $smcFunc, $context;
	$memberid = (int) $context['user']['id'];
	$request = $smcFunc['db_query']('', '
			SELECT id
			FROM {db_prefix}achievements_members
			WHERE achievement = {int:achievement} AND
				ownerid = {int:ownerid}',
			array(
				'achievement' => $achievementid,
				'ownerid' => $memberid,
				));
		if ($smcFunc['db_num_rows']($request) == 0) {

			// Update the item information
			$smcFunc['db_query']('', "
			INSERT INTO {db_prefix}achievements_members
			(`ownerid`, `achievement`, `display`)
			VALUES (
				{int:ownerid},
				{int:achievement},
				1)",
			array(
				'achievement' => $achievementid,
				'ownerid' => $memberid,
				));

			$smcFunc['db_query']('', "
			INSERT INTO {db_prefix}achievements_history
			(`ownerid`, `achievement`, `action`, `audit_member_id`, `event_time`)
			VALUES (
				{int:ownerid},
				{int:achievement},
				'add',
				{int:auditId},
				{int:eventTime})",
			array(
				'achievement' => $achievementid,
				'ownerid' => $memberid,
				'eventTime' => time(),
				'auditId' => $memberid,
				));
		}

		$smcFunc['db_free_result']($request);
}

function scheduled_autoGrantAchievements()
{
	global $smcFunc;
    
    $result = $smcFunc['db_query']('', "
		SELECT id, table_name, id_field, comparison_field, comparison_type, comparison_value
		FROM {db_prefix}achievements_info",
		array(
        ));

    while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		try {
			if (isset($row['table_name']) && strlen($row['table_name']) > 0 &&
				isset($row['id_field']) && strlen($row['id_field']) > 0 &&
				isset($row['comparison_field']) && strlen($row['comparison_field']) > 0) {
				giveTableBasedAchievement($row['id'], $row['table_name'], $row['id_field'], $row['comparison_field'], $row['comparison_type'], $row['comparison_value']);	
			}
		} catch(Exception $e) {
			echo 'Caught exception: ',  $e->getMessage(), "\n";
		}
    }

	$smcFunc['db_free_result']($result);
}

function giveTableBasedAchievement($id, $table, $memberidfield, $tableField, $comparisonType, $comparisonValue) {
	global $smcFunc;

    $clause = $tableField . $comparisonType . ' "' . $comparisonValue . '"';
	$result = $smcFunc['db_query']('', "
    SELECT " . $memberidfield . " as member_id
    FROM {db_prefix}" . $table . "
    WHERE {raw:clause}",
    array(
        'clause' => $clause,
    ));

    // check if users have achievement, and if not, assign
    while ($row = $smcFunc['db_fetch_assoc']($result))
    {
		maybeGiveMemberAchievement($row['member_id'], $id);
    }

    $smcFunc['db_free_result']($result);
}

function maybeGiveMemberAchievement($memberid, $achievementid) {
	global $smcFunc;
	$request = $smcFunc['db_query']('', '
			SELECT id
			FROM {db_prefix}achievements_members
			WHERE achievement = {int:achievement} AND
				ownerid = {int:ownerid}',
			array(
				'achievement' => $achievementid,
				'ownerid' => $memberid,
				));
		if ($smcFunc['db_num_rows']($request) == 0) {

			// Update the item information
			$smcFunc['db_query']('', "
			INSERT INTO {db_prefix}achievements_members
			(`ownerid`, `achievement`, `display`)
			VALUES (
				{int:ownerid},
				{int:achievement},
				1)",
			array(
				'achievement' => $achievementid,
				'ownerid' => $memberid,
				));

			$smcFunc['db_query']('', "
			INSERT INTO {db_prefix}achievements_history
			(`ownerid`, `achievement`, `action`, `audit_member_id`, `event_time`)
			VALUES (
				{int:ownerid},
				{int:achievement},
				'add',
				-1,
				{int:eventTime})",
			array(
				'achievement' => $achievementid,
				'ownerid' => $memberid,
				'eventTime' => time(),
				));
		}

		$smcFunc['db_free_result']($request);
}