<?php

// If the file isn't called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');

// During testing, caching was causing many problems. So, we try to disable the caching here
// header('Expires: Fri, 1 Jun 1990 00:00:00 GMT'); // My birthday ;)
// header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT');
// header('Pragma: no-cache');

// Load the language file
loadLanguage('Achievements');

//Add mod settings in admin panel.	
function AchievementsAdminArea(&$admin_areas)
{
	global $txt;
	$admin_areas += array('customachievements' => array(
		'title' => $txt['achievements_admin'],
		'permission' => array('achievements_admin'),
		'areas' => array(
			'achievements_info' => array(
				'label' => $txt['achievements_info'],
				'file' => 'achievements/AchievementsAdmin.php',
				'function' => 'AchievementsInfo',
			),
			'achievements_members' => array(
				'label' => $txt['achievements_members'],
				'file' => 'achievements/AchievementsAdmin.php',
				'function' => 'AchievementsMembers',
			),
			'achievements_audit' => array(
				'label' => $txt['achievements_audit'],
				'file' => 'achievements/AchievementsAdmin.php',
				'function' => 'AchievementsAudit',
			),
		),),
	);
	return $admin_areas;
}

// Achievement information mamangement page
function AchievementsInfo()
{
	// Check if they're allowed here
	isAllowedTo('achievements_admin');
	global $smcFunc, $context, $db_prefix, $modSettings, $txt, $scripturl;

	// Images
	$context['achievement_images'] = getImageList();

	if (isset($_GET['do']) && $_GET['do'] == 'duplicate')
	{
		// Make sure ID is numeric
		$_GET['id'] = (int) $_GET['id'];
		// Get the achievement's information
		$result = $smcFunc['db_query']('', "
			SELECT `name`, `desc`, link, category, id, image, table_name, id_field, comparison_field, comparison_type, comparison_value, enabled
			FROM {db_prefix}achievements_info
			WHERE id = {int:id}",
			array(
				'id' => $_GET['id'],
			));
		$row = $smcFunc['db_fetch_assoc']($result);
		$smcFunc['db_free_result']($result);

		// Set all the information (for use in the template)
		$context['achievements_edit'] = array(
			'name' => $row['name'],
			'desc' => $row['desc'],
			'link' => $row['link'],
			'image' => $row['image'],
			'category' => $row['category'],
			'table_name' => $row['table_name'],
			'id_field' => $row['id_field'],
			'comparison_field' => $row['comparison_field'],
			'comparison_type' => $row['comparison_type'],
			'comparison_value' => $row['comparison_value'],
			'enabled' => $row['enabled'],
			);

		// We need to load the add/edit template
		$context['sub_template'] = 'achievements_add';
		// Set the page title
		$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_adding'];
		// Load the administration template
		loadTemplate('AchievementsAdmin');
		return;
	}
	// If we're editing something (they've clicked the 'Edit' link)
	elseif (isset($_GET['do']) && $_GET['do'] == 'edit')
	{
		// Make sure ID is numeric
		$_GET['id'] = (int) $_GET['id'];
		// Get the achievement's information
		$result = $smcFunc['db_query']('', "
			SELECT `name`, `desc`, link, category, id, image, table_name, id_field, comparison_field, comparison_type, comparison_value, enabled
			FROM {db_prefix}achievements_info
			WHERE id = {int:id}",
			array(
				'id' => $_GET['id'],
			));
		$row = $smcFunc['db_fetch_assoc']($result);
		$smcFunc['db_free_result']($result);

		// Set all the information (for use in the template)
		$context['achievements_edit'] = array(
			'id' => $_GET['id'],
			'name' => $row['name'],
			'desc' => $row['desc'],
			'link' => $row['link'],
			'image' => $row['image'],
			'category' => $row['category'],
			'table_name' => $row['table_name'],
			'id_field' => $row['id_field'],
			'comparison_field' => $row['comparison_field'],
			'comparison_type' => $row['comparison_type'],
			'comparison_value' => $row['comparison_value'],
			'enabled' => $row['enabled'],
			);

		// We need to load the add/edit template
		$context['sub_template'] = 'achievements_edit';
		// Set the page title
		$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_editing'];
		// Load the administration template
		loadTemplate('AchievementsAdmin');
		return;
	}
	elseif (isset($_GET['do']) && $_GET['do'] == 'add') {
		// We need to load the add/edit template
		$context['sub_template'] = 'achievements_add';
		// Set the page title
		$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_adding'];
		// Load the administration template
		loadTemplate('AchievementsAdmin');
		return;
	}
	// If they've chosen to delete an achievement
	elseif (isset($_GET['do']) && $_GET['do'] == 'delete')
	{
		// Make sure ID is numeric
		$_GET['id'] = (int) $_GET['id'];

		// Delete the achievement
		$smcFunc['db_query']('', '
			DELETE FROM {db_prefix}achievements_info
			WHERE id = {int:id}',
			array(
				'id' => $_GET['id'],
			));

	// If anyone had this achievement, they don't anymore :P
	$smcFunc['db_query']('', '
		DELETE FROM {db_prefix}achievements_members
		WHERE achievement = {int:id}',
		array(
			'id' => $_GET['id'],
		));

	// This is used in the template for the message at the top
	$context['achievement_edit_message'] = $txt['achievement_deleted'];
	}
	// If we're saving changes to the item
	elseif (isset($_GET['do']) && $_GET['do'] == 'save')
	{
		// Make sure some inputs are numeric
		$_POST['id'] = (int) $_POST['id'];

		// Update the item information
		$smcFunc['db_query']('', "
			UPDATE {db_prefix}achievements_info
			SET
				`name` = {string:name},
				`desc` = {string:desc},
				`link` = {string:link},
				`category` = {string:cat},
				`image` = {string:image},
				`table_name` = {string:table_name},
				`id_field` = {string:id_field},
				`comparison_field` = {string:comparison_field},
				`comparison_type` = {string:comparison_type},
				`comparison_value` = {string:comparison_value},
				`enabled` = {int:enabled}
			WHERE id = {int:id}
			LIMIT 1",
			array(
				'name' => validate_string($_POST['ach_name']),
				'desc' => validate_string($_POST['ach_desc']),
				'link' => validate_string($_POST['ach_link']),
				'cat' => validate_string($_POST['ach_cat']),
				'image' => validate_string($_POST['icon']),
				'table_name' => validate_string($_POST['ach_table']),
				'id_field' => validate_string($_POST['ach_id_field']),
				'comparison_field' => validate_string($_POST['ach_comp_field']),
				'comparison_type' => validate_operators($_POST['ach_comp']),
				'comparison_value' => validate_string($_POST['ach_comp_value']),
				'enabled' => $_POST['ach_enabled']  == 'on' ? 1 : 0,
				'id' => $_POST['id'],
				));

		// This is used in the template for the message at the top
		$context['achievement_edit_message'] = $txt['achievement_saved'];
	}
	// If we're saving changes to the item
	elseif (isset($_GET['do']) && $_GET['do'] == 'add_save')
	{
		// Update the item information
		$smcFunc['db_query']('', "
			INSERT INTO {db_prefix}achievements_info
			(`name`, `desc`, `link`, `category`, `image`, `table_name`, `id_field`, `comparison_field`, `comparison_type`, `comparison_value`, `enabled`)
			VALUES (
				 {string:name},
				 {string:desc},
				 {string:link},
				 {string:cat},
				 {string:image},
				 {string:table_name},
				 {string:id_field},
				 {string:comparison_field},
				 {string:comparison_type},
				 {string:comparison_value},
				 {int:enabled})",
			array(
				'name' => validate_string($_POST['ach_name']),
				'desc' => validate_string($_POST['ach_desc']),
				'link' => validate_string($_POST['ach_link']),
				'cat' => validate_string($_POST['ach_cat']),
				'image' => validate_string($_POST['icon']),
				'table_name' => validate_string($_POST['ach_table']),
				'id_field' => validate_string($_POST['ach_id_field']),
				'comparison_field' => validate_string($_POST['ach_comp_field']),
				'comparison_type' => validate_operators($_POST['ach_comp']),
				'comparison_value' => validate_string($_POST['ach_comp_value']),
				'enabled' => $_POST['ach_enabled'] == 'on' ? 1 : 0,
				));

		// This is used in the template for the message at the top
		$context['achievement_edit_message'] = $txt['achievement_saved'];
	} elseif (isset($_GET['do']) && $_GET['do'] == 'bulk_save') {
		foreach($_POST['ach_list'] as $id) {
			if (is_numeric($id)) {
				$smcFunc['db_query']('', "
					UPDATE {db_prefix}achievements_info
					SET
					`name` = {string:name},
					`desc` = {string:desc},
					`link` = {string:link},
					`image` = {string:image},
					`category` = {string:cat},
					`enabled` = {int:enabled}
				WHERE id = {int:id}
				LIMIT 1",
				array(
					'name' => validate_string($_POST['ach_name'][$id]),
					'desc' => validate_string($_POST['ach_desc'][$id]),
					'link' => validate_string($_POST['ach_link'][$id]),
					'cat' => validate_string($_POST['ach_cat'][$id]),
					'image' => validate_string($_POST['icon'][$id]),
					'enabled' => $_POST['ach_enabled'][$id]  == 'on' ? 1 : 0,
					'id' => $id,
				));
			}
		}

		// This is used in the template for the message at the top
		$context['achievement_edit_message'] = $txt['achievement_saved'];
	}

	// If the sort method isn't defined, assume a default
	if (!isset($_GET['sort']) || !is_numeric($_GET['sort']))
		$_GET['sort'] = '0';
	if (!isset($_GET['sortDir']) || !is_numeric($_GET['sortDir']))
		$_GET['sortDir'] = '0';
	// If the page is not set, assume page 1
	if (!isset($_GET['page']) || !is_numeric($_GET['page']))
		$_GET['page'] = 1;
	
	// Get the sort type
	switch($_GET['sort'])
	{
		case 0:
			$context['achievements_info']['sort_type'] = $txt['achievement_name'];
			$sortQuery = 'name';
			break;
		case 1:
			$context['achievements_info']['sort_type'] = $txt['achievement_description'];
			$sortQuery = '`desc`';
			break;
		case 2:
			$context['achievements_info']['sort_type'] = $txt['achievement_category'];
			$sortQuery = 'category';
            break;
        case 3:
            $context['achievements_info']['sort_type'] = $txt['achievement_link'];
            $sortQuery = 'link';
			break;
		case 4:
			$context['achievements_info']['sort_type'] = $txt['achievement_table_name'];
			$sortQuery = 'table_name';
			break;
        case 5:
            $context['achievements_info']['sort_type'] = $txt['achievement_comparison_field'];
            $sortQuery = 'comparison_field';
			break;
		default:
			fatal_error("Invalid sort method passed");
			break;
	}
	
	// And the direction
	switch($_GET['sortDir'])
	{
		case 0:
			$context['achievements_info']['sort_dir'] = $txt['achievements_asc'];
			$sortDirQuery = 'ASC';
			break;
		case 1:
			$context['achievements_info']['sort_dir'] = $txt['achievements_desc'];
			$sortDirQuery = 'DESC';
			break;	
		default:
			fatal_error("Invalid sort direction passed");
			break;
	}	
	// Tell the template we need the sort box at the top
	$context['achievements_info']['sort'] = true;

	// Are we only displaying a certain category?
	if (isset($_GET['cat']) && $_GET['cat'] != -1)
	{
		if ($_GET['cat'] === "0") {
			$context['achievements_info']['category'] = $_GET['cat'];
			$catClause = 'WHERE category = ""' ;
		} else {
			$context['achievements_info']['category'] = $_GET['cat'];
			$catClause = 'WHERE category = "' . $context['achievements_info']['category'] . '"';
		}
	}
	else
	{
		$context['achievements_info']['category'] = -1;
		$catClause = '';
	}

	// Get the number of items available
	$result = $smcFunc['db_query']('', "
		SELECT COUNT(id)
		FROM {db_prefix}achievements_info
		{raw:clause}",
		array(
			'clause' => $catClause
		));
	list ($context['achievements_info']['item_count']) = $smcFunc['db_fetch_row']($result);
	
	// The page count - Total number of items divided by number per page
	$context['achievements_info']['pages']['total'] = ceil($context['achievements_info']['item_count'] / $modSettings['achievementInfoPerPage']);
	// First item
	$firstItem = ($_GET['page'] - 1) * $modSettings['achievementInfoPerPage'];

	// Start with empty items array
	$context['achievements_info']['achievements'] = array();
    // Get all the items on this page
	$result = $smcFunc['db_query']('', "
		SELECT `name`, `desc`, link, category, id, image, table_name, id_field, comparison_field, comparison_type, comparison_value, enabled
		FROM {db_prefix}achievements_info
		{raw:clause}
		ORDER BY {raw:sort} {raw:sortdir}
		LIMIT {int:firstItem}, {int:perPage}",
		array(
			'clause' => $catClause,
			'sort' => $sortQuery,
			'sortdir' => $sortDirQuery,
			'firstItem' => $firstItem,
			'perPage' => $modSettings['achievementInfoPerPage'],
        ));
        
	$cats = array();
	
	// Store the cipher method 
	$ciphering = "AES-128-CTR"; 
	// Use OpenSSl Encryption method 
	$options = 0; 
	$bytes = "";
	if (function_exists('random_bytes')) {
		$bytes = random_bytes(openssl_cipher_iv_length('AES-128-CTR') / 2);
	} else {
		$bytes = openssl_random_pseudo_bytes(openssl_cipher_iv_length('AES-128-CTR') / 2);
	}
	$encryption_iv = bin2hex($bytes);
	// Get the encryption key 
	$encryption_key = $modSettings['cjdsmfachievementsSSLkey'];

	// Loop through results...
    while ($row = $smcFunc['db_fetch_assoc']($result))
    {
		// Get the number of achievements assigned
		$countResult = $smcFunc['db_query']('', "
		SELECT COUNT(ownerid) as count
		FROM {db_prefix}achievements_members
		WHERE achievement = {int:achievement}",
		array(
			'achievement' => $row['id'],
		));

		// ... and add it to the array
		$context['achievements_info']['achievements'][] = array(
			
            'id' => $row['id'],
            'name' => $row['name'],
            'desc' => $row['desc'],
            'link' => $row['link'],
            'image' => $row['image'],
            'category' => $row['category'],
			'table_name' => $row['table_name'],
			'id_field' => $row['id_field'],
            'comparison_field' => $row['comparison_field'],
            'comparison_type' => $row['comparison_type'],
			'comparison_value' => $row['comparison_value'],
			'enabled' => $row['enabled'],
			'user_count' => $smcFunc['db_fetch_assoc']($countResult)['count'],
			'hash' => rawurlencode(openssl_encrypt($row['id'], $ciphering, $encryption_key, $options, $encryption_iv)),
			'iv' => rawurlencode(strval($encryption_iv)),
		);

        if ($row['category'] && !in_array($row['category'], $cats)) {
			$cats[] = $row['category'];
		}

		$smcFunc['db_free_result']($countResult);
    }

	$context['achievements_info']['categories'] = $cats;

	$smcFunc['db_free_result']($result);
	
	// Miscellaneous stuff
	$context['achievements_info']['pages']['current'] = $_GET['page'];
	$context['achievements_info']['pages']['link'] = $scripturl . '?action=admin;area=achievements_info;sort=' . $_GET['sort'] . ';sortDir=' . $_GET['sortDir'];
	if (isset($context['achievements_info']['category']))
        $context['achievements_info']['pages']['link'] .= ';cat=' . $context['achievements_info']['category'];

    // We need to load the add/edit template
	$context['sub_template'] = 'achievements_add_edit';
	// Set the page title
	$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_info'];
	// Load the administration template
	loadTemplate('AchievementsAdmin');
}

// Achievement reward mamangement page
function AchievementsMembers()
{
	// Check if they're allowed here
	isAllowedTo('achievements_admin');
	global $smcFunc, $context, $db_prefix, $modSettings, $txt, $scripturl;


	if (isset($_GET['do']) && $_GET['do'] == 'delete')
	{
		// Make sure ID is numeric
		$_GET['id'] = (int) $_GET['id'];
		removeById($_GET['id']);
		// This is used in the template for the message at the top
		$context['achievement_edit_message'] = $txt['achievement_deleted'];
	} elseif (isset($_GET['do']) && $_GET['do'] == 'add') {
		if (isset($_POST['ach']) && is_numeric($_POST['ach']) &&
			isset($_POST['userid']) && is_numeric($_POST['userid'])) {
			adminMaybeGiveMemberAchievement($_POST['userid'], $_POST['ach']);
			// This is used in the template for the message at the top
			$context['achievement_edit_message'] = $txt['achievement_saved'];
		}
	}

	if ((isset($_GET['do']) && $_GET['do'] == 'viewach') || isset($_REQUEST['achid'])) {
		AchievementsOwners();
		return;
	}

	// Start with empty items array
	$context['achievements_members']['achievements'] = array();
    // Get all the items on this page
	$result = $smcFunc['db_query']('', "
		SELECT `name`, id, image
		FROM {db_prefix}achievements_info",
		array());
	// Loop through results...
    while ($row = $smcFunc['db_fetch_assoc']($result))
    {
		// ... and add it to the array
		$context['achievements_members']['achievements'][] = array(
            'id' => $row['id'],
            'name' => $row['name'],
            'image' => $row['image'],
        );
	}
	$smcFunc['db_free_result']($result);

	if (isset($_GET['do']) && ($_GET['do'] == 'bulk_add' || $_GET['do'] == 'bulk_remove')) {
		if (!isset($_POST['ach']) || !is_numeric($_POST['ach'])) {
			// error
			return;
		}

		// This code from PersonalMessage.php, lines 1531-1535. It trims the " characters off the membername posted,
		// and then puts all names into an array
		$_REQUEST['searchfor'] = strtr($_REQUEST['searchfor'], array('\\"' => '"'));
		preg_match_all('~"([^"]+)"~', $_REQUEST['searchfor'], $matches);
		$searchforArray = array_unique(array_merge($matches[1], explode(',', preg_replace('~"([^"]+)"~', '', $_REQUEST['searchfor']))));

		foreach($searchforArray as $username) {
			// Get the user's information
			$result = $smcFunc['db_query']('', "
				SELECT id_member
				FROM {db_prefix}members
				WHERE member_name = ({string:membername}) OR real_name = ({string:membername})
				LIMIT 1",
				array(
					'membername' => $username,
				));

			// Loop through results...
			while ($row = $smcFunc['db_fetch_assoc']($result))
			{

				if ($_GET['do'] == 'bulk_remove') {
					removeMemberAchievement($row['id_member'], $_POST['ach']);
				} elseif ($_GET['do'] == 'bulk_add') {
					adminMaybeGiveMemberAchievement($row['id_member'], $_POST['ach']);
				}
			}

			$smcFunc['db_free_result']($result);
		}

		$context['achievements_message'] = $txt['achievements_updated'];
		// We need to load the member achievements template
		$context['sub_template'] = 'search_for_member';
		// Set the page title
		$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_members'];
		// Load the administration template
		loadTemplate('AchievementsAdmin');
		return;
	}

	if (!isset($_GET['do'])) {		
		// We need to load the member achievements template
		$context['sub_template'] = 'search_for_member';
		// Set the page title
		$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_members'];
		// Load the administration template
		loadTemplate('AchievementsAdmin');
		return;
	}

	// User ID rather than name?
	if (isset($_REQUEST['userid']) && $_REQUEST['userid'] != 0 && is_numeric($_REQUEST['userid']))
	{
		$_REQUEST['userid'] = (int) $_REQUEST['userid'];
		$clause = 'ID_MEMBER = ' . $_REQUEST['userid'];
	}
	// A name is passed instead
	else
	{
		// This code from PersonalMessage.php, lines 1531-1535. It trims the " characters off the membername posted,
		// and then puts all names into an array
		$_REQUEST['searchfor'] = strtr($_REQUEST['searchfor'], array('\\"' => '"'));
		preg_match_all('~"([^"]+)"~', $_REQUEST['searchfor'], $matches);
		$searchforArray = array_unique(array_merge($matches[1], explode(',', preg_replace('~"([^"]+)"~', '', $_REQUEST['searchfor']))));

		// We only want the first memberName found
		$searchfor = $searchforArray[0];

		$clause = 'member_name = "' . $searchfor . '" OR real_name = "' . $searchfor . '"';
	}

	// Get the user's information
	$result = $smcFunc['db_query']('', "
		SELECT id_member, member_name, real_name
		FROM {db_prefix}members
		WHERE {raw:clause}
		LIMIT 1",
		array(
			'clause' => $clause,
		));

	// If this user doesn't exist
	if ($smcFunc['db_num_rows']($result) == 0)
	{
		// Show an error!
		fatal_error(sprintf($txt['achievement_member_no_exist'], $_REQUEST['searchfor']));
		return;
	}
	
	// Get their information
	$row = $smcFunc['db_fetch_assoc']($result);
	$smcFunc['db_free_result']($result);

	// Set up the array of inventory information
	$context['achievements_members']['member'] = $row['id_member'];
	$context['achievements_members']['real_name'] = $row['real_name'];
	$context['achievements_members']['member_name'] = $row['member_name'];

	// If the sort method isn't defined, assume a default
	if (!isset($_GET['sort']) || !is_numeric($_GET['sort']))
		$_GET['sort'] = '0';
	if (!isset($_GET['sortDir']) || !is_numeric($_GET['sortDir']))
		$_GET['sortDir'] = '0';
	// If the page is not set, assume page 1
	if (!isset($_GET['page']) || !is_numeric($_GET['page']))
		$_GET['page'] = 1;
	
	// Get the sort type
	switch($_GET['sort'])
	{
		case 0:
			$context['achievements_members']['sort_type'] = $txt['achievement_name'];
			$sortQuery = 'achievement_name';
			break;
		default:
			fatal_error("Invalid sort method passed");
			break;
	}
	
	// And the direction
	switch($_GET['sortDir'])
	{
		case 0:
			$context['achievements_members']['sort_dir'] = $txt['achievements_asc'];
			$sortDirQuery = 'ASC';
			break;
		case 1:
			$context['achievements_members']['sort_dir'] = $txt['achievements_desc'];
			$sortDirQuery = 'DESC';
			break;	
		default:
			fatal_error("Invalid sort direction passed");
			break;
	}	
	// Tell the template we need the sort box at the top
	$context['achievements_members']['sort'] = true;

	// Get the number of achievements assigned
	$result = $smcFunc['db_query']('', "
		SELECT COUNT(id)
		FROM {db_prefix}achievements_members
		WHERE ownerid = {int:member}",
		array(
			'member' => $context['achievements_members']['member'],
		));
	list ($context['achievements_members']['item_count']) = $smcFunc['db_fetch_row']($result);
	
	// The page count - Total number of items divided by number per page
	$context['achievements_members']['pages']['total'] = ceil($context['achievements_members']['item_count'] / $modSettings['achievementInfoPerPage']);
	// First item
	$firstItem = ($_GET['page'] - 1) * $modSettings['achievementInfoPerPage'];

	// Start with empty items array
	$context['achievements_members']['members'] = array();
	// Get all the items on this page
	$result = $smcFunc['db_query']('', '
		SELECT i.image as achievement_image, i.name as achievement_name, am.id as id, am.achievement as ach_id
		FROM {db_prefix}achievements_members as am
			INNER JOIN {db_prefix}achievements_info AS i ON (am.achievement = i.id)
		WHERE ownerid = {int:member}
		ORDER BY {raw:sort} {raw:sortdir}
		LIMIT {int:firstItem}, {int:perPage}',
		array(
			'member' => $context['achievements_members']['member'],
			'sort' => $sortQuery,
			'sortdir' => $sortDirQuery,
			'firstItem' => $firstItem,
			'perPage' => $modSettings['achievementInfoPerPage'],
		)
	);

	// Loop through results...
    while ($row = $smcFunc['db_fetch_assoc']($result))
    {
		// ... and add it to the array
		$context['achievements_members']['members'][] = array(
            'id' => $row['id'],
			'achievement_name' => $row['achievement_name'],
			'achievement_image' => $row['achievement_image'],
			'ach_id' => $row['ach_id'],
        );
	}

	$smcFunc['db_free_result']($result);
	
	// Miscellaneous stuff
	$context['achievements_members']['pages']['current'] = $_GET['page'];
	$context['achievements_members']['pages']['link'] = $scripturl . '?action=admin;area=achievements_members;do=viewmember;sort=' . $_GET['sort'] . ';sortDir=' . $_GET['sortDir'];
	if (isset($context['achievements_members']['category']))
		$context['achievements_members']['pages']['link'] .= ';cat=' . $context['achievements_members']['category'];
		
	$context['achievements_members']['pages']['link'] .= '&userid=' . $context['achievements_members']['member'];

    // We need to load the member achievements template
	$context['sub_template'] = 'member_achievements';
	// Set the page title
	$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_members'];
	// Load the administration template
	loadTemplate('AchievementsAdmin');
}

// Achievement reward mamangement page
function AchievementsOwners()
{
	// Check if they're allowed here
	isAllowedTo('achievements_admin');
	global $smcFunc, $context, $db_prefix, $modSettings, $txt, $scripturl;

	// Make sure we have an achievement id.
	if (!isset($_REQUEST['achid']) || !is_numeric($_REQUEST['achid']))
	{
		// error
		return;
	}

	$context['achievements_owners']['achid'] = $_REQUEST['achid'];

	$result = $smcFunc['db_query']('', "
		SELECT `name`, id, image
		FROM {db_prefix}achievements_info
		WHERE id = {int:achievement}",
		array(
			'achievement' => $_REQUEST['achid'],
		));
	// Loop through results...
	while ($row = $smcFunc['db_fetch_assoc']($result))
	{
		$context['achievements_owners']['ach_name'] = $row['name'];
		$context['achievements_owners']['ach_image'] = $row['image'];
	}
	$smcFunc['db_free_result']($result);

	// If the sort method isn't defined, assume a default
	if (!isset($_GET['sort']) || !is_numeric($_GET['sort']))
		$_GET['sort'] = '0';
	if (!isset($_GET['sortDir']) || !is_numeric($_GET['sortDir']))
		$_GET['sortDir'] = '0';
	// If the page is not set, assume page 1
	if (!isset($_GET['page']) || !is_numeric($_GET['page']))
		$_GET['page'] = 1;
	
	// Get the sort type
	switch($_GET['sort'])
	{
		case 0:
			$context['achievements_owners']['sort_type'] = $txt['achievement_name'];
			$sortQuery = 'member_name';
			break;
		case 1:
			$context['achievements_owners']['sort_type'] = $txt['achievement_display_name'];
			$sortQuery = 'real_name';
			break;
		default:
			fatal_error("Invalid sort method passed");
			break;
	}
	
	// And the direction
	switch($_GET['sortDir'])
	{
		case 0:
			$context['achievements_owners']['sort_dir'] = $txt['achievements_asc'];
			$sortDirQuery = 'ASC';
			break;
		case 1:
			$context['achievements_owners']['sort_dir'] = $txt['achievements_desc'];
			$sortDirQuery = 'DESC';
			break;	
		default:
			fatal_error("Invalid sort direction passed");
			break;
	}	
	// Tell the template we need the sort box at the top
	$context['achievements_owners']['sort'] = true;

	// Get the number of achievements assigned
	$result = $smcFunc['db_query']('', "
		SELECT COUNT(id)
		FROM {db_prefix}achievements_members
		WHERE achievement = {int:achievement}",
		array(
			'achievement' => $_REQUEST['achid'],
		));
	list ($context['achievements_owners']['item_count']) = $smcFunc['db_fetch_row']($result);
	
	// The page count - Total number of items divided by number per page
	$context['achievements_owners']['pages']['total'] = ceil($context['achievements_owners']['item_count'] / $modSettings['achievementInfoPerPage']);
	// First item
	$firstItem = ($_GET['page'] - 1) * $modSettings['achievementInfoPerPage'];

	// Start with empty items array
	$context['achievements_owners']['members'] = array();
	// Get all the items on this page
	$result = $smcFunc['db_query']('', '
		SELECT am.id as id, m.id_member as member_id, m.member_name as member_name, m.real_name as real_name
		FROM {db_prefix}achievements_members as am
			INNER JOIN {db_prefix}members as m ON (m.id_member = am.ownerid)
		WHERE am.achievement = {int:achievement}
		ORDER BY {raw:sort} {raw:sortdir}
		LIMIT {int:firstItem}, {int:perPage}',
		array(
			'achievement' => $_REQUEST['achid'],
			'sort' => $sortQuery,
			'sortdir' => $sortDirQuery,
			'firstItem' => $firstItem,
			'perPage' => $modSettings['achievementInfoPerPage'],
		)
	);

	// Loop through results...
    while ($row = $smcFunc['db_fetch_assoc']($result))
    {

		// ... and add it to the array
		$context['achievements_owners']['members'][] = array(
			'id' => $row['id'],
			'member_id' => $row['member_id'],
			'member_name' => $row['member_name'],
			'real_name' => $row['real_name'],
            // 'name' => $row['member_name'],
        );
	}

	$smcFunc['db_free_result']($result);
	
	// Miscellaneous stuff
	$context['achievements_owners']['pages']['current'] = $_GET['page'];
	$context['achievements_owners']['pages']['link'] = $scripturl . '?action=admin;area=achievements_members;do=viewach;sort=' . $_GET['sort'] . ';sortDir=' . $_GET['sortDir'];
	if (isset($context['achievements_owners']['category']))
		$context['achievements_owners']['pages']['link'] .= ';cat=' . $context['achievements_owners']['category'];
		
	$context['achievements_owners']['pages']['link'] .= '&achid=' . $context['achievements_owners']['achid'];

    // We need to load the member achievements template
	$context['sub_template'] = 'achievement_owners';
	// Set the page title
	$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_members'];
	// Load the administration template
	loadTemplate('AchievementsAdmin');
}

function AchievementsAudit() {
	// Check if they're allowed here
	isAllowedTo('achievements_admin');
	global $smcFunc, $context, $db_prefix, $modSettings, $txt, $scripturl;
	// If the sort method isn't defined, assume a default
	if (!isset($_GET['sort']) || !is_numeric($_GET['sort']))
		$_GET['sort'] = '0';
	if (!isset($_GET['sortDir']) || !is_numeric($_GET['sortDir']))
		$_GET['sortDir'] = '0';
	// If the page is not set, assume page 1
	if (!isset($_GET['page']) || !is_numeric($_GET['page']))
		$_GET['page'] = 1;
		
	
	// Get the sort type
	switch($_GET['sort'])
	{
		// time
		case 0:
			$context['achievements_audit']['sort_type'] = $txt['achievement_time'];
			$sortQuery = 'event_time';
			break;
		// member name
		case 1:
			$context['achievements_audit']['sort_type'] = $txt['achievement_name'];
			$sortQuery = 'member_name';
			break;
		// member name
		case 2:
			$context['achievements_audit']['sort_type'] = $txt['achievement_display_name'];
			$sortQuery = 'real_name';
			break;
		// achievement
        case 3:
            $context['achievements_audit']['sort_type'] = $txt['achievement_achievement'];
            $sortQuery = 'ach_name';
			break;
		default:
			fatal_error("Invalid sort method passed");
			break;
	}
	
	// And the direction
	switch($_GET['sortDir'])
	{
		case 0:
			$context['achievements_audit']['sort_dir'] = $txt['achievements_asc'];
			$sortDirQuery = 'ASC';
			break;
		case 1:
			$context['achievements_audit']['sort_dir'] = $txt['achievements_desc'];
			$sortDirQuery = 'DESC';
			break;	
		default:
			fatal_error("Invalid sort direction passed");
			break;
	}	
	// Tell the template we need the sort box at the top
	$context['achievements_audit']['sort'] = true;

	// Get the number of achievements assigned
	$result = $smcFunc['db_query']('', "
		SELECT COUNT(id)
		FROM {db_prefix}achievements_history",
		array());
	list ($context['achievements_audit']['item_count']) = $smcFunc['db_fetch_row']($result);
	
	// The page count - Total number of items divided by number per page
	$context['achievements_audit']['pages']['total'] = ceil($context['achievements_audit']['item_count'] / $modSettings['achievementInfoPerPage']);
	// First item
	$firstItem = ($_GET['page'] - 1) * $modSettings['achievementInfoPerPage'];

	// Start with empty items array
	$context['achievements_audit']['members'] = array();
	// Get all the items on this page
	$result = $smcFunc['db_query']('', '
		SELECT ah.id as id, ah.audit_member_id as audit_member, ah.event_time as event_time,
			ah.action as action, ai.name as ach_name, ai.image as ach_image, ai.id as ach_id,
			m.id_member as member_id, m.member_name as member_name, m.real_name as real_name
		FROM {db_prefix}achievements_history as ah
			INNER JOIN {db_prefix}members as m ON (m.id_member = ah.ownerid)
			INNER JOIN {db_prefix}achievements_info as ai ON (ah.achievement = ai.id)
		ORDER BY {raw:sort} {raw:sortdir}
		LIMIT {int:firstItem}, {int:perPage}',
		array(
			'sort' => $sortQuery,
			'sortdir' => $sortDirQuery,
			'firstItem' => $firstItem,
			'perPage' => $modSettings['achievementInfoPerPage'],
		)
	);

	$auditMemberData = array();
	$auditMemberData['-1'] = array(
		'id_member' => '-1',
		'member_name' => 'scheduled_task',
		'real_name' => 'scheduled_task',
	);	

	// Loop through results...
    while ($row = $smcFunc['db_fetch_assoc']($result))
    {
		// ... and add it to the array
		$newRow = array(
			'id' => $row['id'],
			'event_time' => $row['event_time'],
			'action' => $row['action'],
			'ach_name' => $row['ach_name'],
			'ach_image' => $row['ach_image'],
			'ach_id' => $row['ach_id'],
			'member_id' => $row['member_id'],
			'member_name' => $row['member_name'],
			'real_name' => $row['real_name'],    
		);

		if (!array_key_exists($row['audit_member'], $auditMemberData)) {
			$auditResult = $smcFunc['db_query']('', '
				SELECT id_member, member_name, real_name
				FROM {db_prefix}members
				WHERE id_member = {int:memberId}',
				array(
					'memberId' => $row['audit_member'],
				)
			);

			while ($row = $smcFunc['db_fetch_assoc']($auditResult)) {
				$auditMemberData[$row['id_member']] = array(
					'id_member' => $row['id_member'],
					'member_name' => $row['member_name'],
					'real_name' => $row['real_name'],
				);
				$newRow['audit_member_id'] = $row['id_member'];
				$newRow['audit_member_name'] = $row['member_name'];
				$newRow['audit_member_real_name'] = $row['real_name'];
			}

			$smcFunc['db_free_result']($auditResult);
		} else {
			$newRow['audit_member_id'] = $auditMemberData[$row['audit_member']]['id_member'];
			$newRow['audit_member_name'] = $auditMemberData[$row['audit_member']]['member_name'];
			$newRow['audit_member_real_name'] = $auditMemberData[$row['audit_member']]['real_name'];
		}

		$context['achievements_audit']['members'][] = $newRow;
	}

	$smcFunc['db_free_result']($result);
	
	// Miscellaneous stuff
	$context['achievements_audit']['pages']['current'] = $_GET['page'];
	$context['achievements_audit']['pages']['link'] = $scripturl . '?action=admin;area=achievements_audit;do=viewach;sort=' . $_GET['sort'] . ';sortDir=' . $_GET['sortDir'];
	if (isset($context['achievements_audit']['category']))
		$context['achievements_audit']['pages']['link'] .= ';cat=' . $context['achievements_audit']['category'];

	// We need to load the audit achievements template
	// TODO need to write the achievements audit template
	$context['sub_template'] = 'achievement_audit';
	// Set the page title
	$context['page_title'] = $txt['achievements'] . ' - ' . $txt['achievements_audit'];
	// Load the administration template
	loadTemplate('AchievementsAdmin');
}

function adminMaybeGiveMemberAchievement($memberid, $achievementid) {
	global $smcFunc, $context;
	$request = $smcFunc['db_query']('', '
			SELECT id
			FROM {db_prefix}achievements_members
			WHERE achievement = {int:achievement} AND
				ownerid = {int:ownerid}',
			array(
				'achievement' => $achievementid,
				'ownerid' => $memberid,
				));
		if ($smcFunc['db_num_rows']($request) == 0) {

			// Update the item information
			$smcFunc['db_query']('', "
			INSERT INTO {db_prefix}achievements_members
			(`ownerid`, `achievement`, `display`)
			VALUES (
				{int:ownerid},
				{int:achievement},
				1)",
			array(
				'achievement' => $achievementid,
				'ownerid' => $memberid,
				));

			$smcFunc['db_query']('', "
			INSERT INTO {db_prefix}achievements_history
			(`ownerid`, `achievement`, `action`, `audit_member_id`, `event_time`)
			VALUES (
				{int:ownerid},
				{int:achievement},
				'add',
				{int:auditId},
				{int:eventTime})",
			array(
				'achievement' => $achievementid,
				'ownerid' => $memberid,
				'eventTime' => time(),
				'auditId' => (int) $context['user']['id'],
				));
		}

		$smcFunc['db_free_result']($request);
}

function removeById($id) {
	global $smcFunc;
	$request = $smcFunc['db_query']('', '
		SELECT achievement, ownerid
		FROM {db_prefix}achievements_members
		WHERE id = {int:id}',
		array(
			'id' => $id,
			));
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		removeMemberAchievement($row['ownerid'], $row['achievement']);
	}
	$smcFunc['db_free_result']($request);
}

function removeMemberAchievement($memberid, $achievementid) {
	global $smcFunc, $context;
	$smcFunc['db_query']('', '
		DELETE FROM {db_prefix}achievements_members
		WHERE achievement = {int:achievement} AND ownerid = {int:ownerid}',
		array(
			'achievement' => $achievementid,
			'ownerid' => $memberid,
		));

	$smcFunc['db_query']('', "
		INSERT INTO {db_prefix}achievements_history
		(`ownerid`, `achievement`, `action`, `audit_member_id`, `event_time`)
		VALUES (
			{int:ownerid},
			{int:achievement},
			'remove',
			{int:auditId},
			{int:eventTime})",
		array(
			'achievement' => $achievementid,
			'ownerid' => $memberid,
			'eventTime' => time(),
			'auditId' => (int) $context['user']['id'],
			));
}

function getImageList()
{
	global $sourcedir;

	// Start with an empty array
	$imageList = array();
	// Try to open the images directory
	if ($handle = opendir($sourcedir . '/achievements/images'))
	{
		// For each file in the directory...
		while (false !== ($file = readdir($handle)))
		{
			// ...if it's a valid file, add it to the list
			if (!in_array($file, array('.', '..', 'blank.gif')))
				$imageList[] = $file;
		}
		// Sort the list
		sort($imageList);
		return $imageList;
	}
	// Otherwise, if directory inaccessible, show an error
	else
	{
		fatal_lang_error('achievements_cannot_open_images');
	}
}

function validate_string($data) {
	global $smcFunc;
	$data = $smcFunc['htmlspecialchars']($data, ENT_QUOTES);
	return $data;
 }

 function validate_operators($data) {
	$operatorList = array('&', '|', '^', '=', '>', '<', '>=', '<=', '<>',
		 'ALL', 'AND', 'ANY', 'BETWEEN', 'EXISTS', 'IN', 'LIKE', 'NOT', 'OR', 'SOME');
	$data = trim($data);
	$data = stripslashes($data);
	$data = strtoupper($data);
	if (in_array($data, $operatorList )) {
		return $data;
	}
	return '';
 }

?>