<?php


global $smcFunc, $db_prefix, $modSettings;

// // Add a column for money
// $smcFunc['db_add_column']('{db_prefix}members', array(
// 	'name' => 'money',
// 	'type' => 'decimal',
// 	'default' => '0.00',
// 	));

// // Add a column for banked money
// $smcFunc['db_add_column']('{db_prefix}members', array(
// 	'name' => 'moneyBank',
// 	'type' => 'decimal',
// 	'default' => '0.00',
// 	));

// Add your mod setting to the database
if(!isset($modSettings['achievementImageWidth']))
	$smcFunc['db_query']('', '
		INSERT INTO {db_prefix}settings
		VALUES ("achievementImageWidth", 32)',
		array()
	);
if(!isset($modSettings['achievementImageHeight']))
	$smcFunc['db_query']('', '
		INSERT INTO {db_prefix}settings
		VALUES ("achievementImageHeight", 32)',
		array()
	);
if(!isset($modSettings['achievementInfoPerPage']))
	$smcFunc['db_query']('', '
		INSERT INTO {db_prefix}settings
		VALUES ("achievementInfoPerPage", 25)',
		array()
	);
if(!isset($modSettings['cjdsmfachievementsSSLkey'])) {
	$bytes = "";
	if (function_exists('random_bytes')) {
		$bytes = random_bytes(64);
	} else {
		$bytes = openssl_random_pseudo_bytes(64);
	}
	$key = bin2hex($bytes);
	$smcFunc['db_query']('', '
		INSERT INTO {db_prefix}settings
		VALUES ("cjdsmfachievementsSSLkey", {string:key})',
		array(
			'key' => $key,
		)
	);
}

$request = $smcFunc['db_query']('', '
	SELECT id_task FROM {db_prefix}scheduled_tasks WHERE task = {string:task}',
	array(
		'task' => 'autoGrantAchievements',
	)
);
if ($smcFunc['db_num_rows']($request) == 0)
	$smcFunc['db_insert']('insert',
		'{db_prefix}scheduled_tasks',
		array(
			'next_time' => 'int', 'time_offset' => 'int', 'time_regularity' => 'int',
			'time_unit' => 'string', 'disabled' => 'int', 'task' => 'string',
		),
		array(
			0, 0, 2, 'h', 0, 'autoGrantAchievements',
		),
		array('id_task')
	);
$smcFunc['db_free_result']($request);

// Achievement info table
$smcFunc['db_create_table']('{db_prefix}achievements_info',
	array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'name',
			'type' => 'varchar',
			'size' => 50,
		),
		array(
			'name' => 'desc',
			'type' => 'text',
		),
		array(
			'name' => 'link',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'image',
			'type' => 'tinytext',
			'null' => true,
		),
		array(
			'name' => 'category',
			'type' => 'varchar',
			'size' => 50,
		),
		array(
			'name' => 'table_name',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'id_field',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'comparison_field',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'comparison_type',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'comparison_value',
			'type' => 'text',
			'null' => true,
		),
		array(
			'name' => 'enabled',
			'type' => 'int',
			'size' => 4,
			'default' => 1,
		),	
	),
	array(
		array(
			'name' => 'id',
			'type' => 'primary',
			'columns' => array('id'),
		),
	),
	array(),
	'overwrite');

// Achievements owned table
$smcFunc['db_create_table']('{db_prefix}achievements_members',
	array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'ownerid',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'achievement',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'display',
			'type' => 'int',
			'size' => 4,
		),
	),
	array(
		array(
			'name' => 'id',
			'type' => 'primary',
			'columns' => array('id'),
		),
	),
	array(),
	'overwrite');

// Achievements history table
$smcFunc['db_create_table']('{db_prefix}achievements_history',
	array(
		array(
			'name' => 'id',
			'type' => 'int',
			'size' => 10,
			'auto' => true,
		),
		array(
			'name' => 'ownerid',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'achievement',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'action',
			'type' => 'tinytext',
			'null' => true,
		),
		array(
			'name' => 'audit_member_id',
			'type' => 'int',
			'size' => 10,
		),
		array(
			'name' => 'event_time',
			'type' => 'int',
			'size' => 10,
			'null' => false,
			'default' => 0,
		),
	),
	array(
		array(
			'name' => 'id',
			'type' => 'primary',
			'columns' => array('id'),
		),
	),
	array(),
	'overwrite');

// Insert shop items
$smcFunc['db_insert']('insert', '{db_prefix}achievements_info',

	// Fields
	array(
		'name' => 'string',
		'desc' => 'string',
		'link' => 'string',
		'image' => 'string',
		'category' => 'string',
		'table_name' => 'string',
		'id_field' => 'string',
		'comparison_field' => 'string',
		'comparison_type' => 'string',
		'comparison_value' => 'int',
		),

	// Values
	array(
		// first post
		array(
			'name' => 'You Posted!',
			'desc' => 'Earned for posting at least 1 time.',
			'link' => 'https://chrisjohn.digital',
			'image' => 'Darkbeer.gif',
			'category' => 'posts',
			'table_name' => 'members',
			'id_field' => 'id_member',
			'comparison_field' => 'posts',
			'comparison_type' => '>',
			'comparison_value' => '0',
			),
			// 10 posts
		array(
			'name' => 'Have something to say!',
			'desc' => 'Earned for posting at least 10 times.',
			'link' => 'https://chrisjohn.digital',
			'image' => 'Fish.gif',
			'category' => 'posts',
			'table_name' => 'members',
			'id_field' => 'id_member',
			'comparison_field' => 'posts',
			'comparison_type' => '>',
			'comparison_value' => '9',
			),
			// 100 posts
		array(
			'name' => 'Talkative!',
			'desc' => 'Earned for posting at least 100 times.',
			'link' => 'https://chrisjohn.digital',
			'image' => 'IronDevil.gif',
			'category' => 'posts',
			'table_name' => 'members',
			'id_field' => 'id_member',
			'comparison_field' => 'posts',
			'comparison_type' => '>',
			'comparison_value' => '99',
			),
			// 1000 posts
		array(
			'name' => 'You should be a moderator!',
			'desc' => 'Earned for posting at least 1000 times.',
			'link' => 'https://chrisjohn.digital',
			'image' => 'Makecoffee.gif',
			'category' => 'posts',
			'table_name' => 'members',
			'id_field' => 'id_member',
			'comparison_field' => 'posts',
			'comparison_type' => '>',
			'comparison_value' => '999',
			),
		// array(
		// 	'name' => 'Bought store item 3!',
		// 	'desc' => 'Earned for buying store item 3.',
		// 	'link' => '',
		// 	'image' => 'Makecoffee.gif',
		// 	'category' => 'store',
		// 	'table_name' => 'shop_inventory',
		// 	'id_field' => 'ownerid',
		// 	'comparison_field' => 'itemid',
		// 	'comparison_type' => '=',
		// 	'comparison_value' => '3',
		// 	),
		// array(
		// 	'name' => 'Bought anything!',
		// 	'desc' => 'Earned for buying anything from the store.',
		// 	'link' => '',
		// 	'image' => 'Makecoffee.gif',
		// 	'category' => 'store',
		// 	'table_name' => 'shop_inventory',
		// 	'id_field' => 'ownerid',
		// 	'comparison_field' => 'itemid',
		// 	'comparison_type' => '!=',
		// 	'comparison_value' => '-1',
		// 	),
		),
	array());
?>